<id>
PointsMod for SP1.3
</id>

<version>
version 1.2.1
</version>

<mod info>
This mod implements a point counter mechanism for board moderation.

+ It adds a new field into user profiles: Poster's Points
+ The admin & moderators can lower the points if they see inappropriate posts.
+ If a user's points total dips below 0, he/she cannot post.
+ The points count regenerates slowly, given time.
+ When the counter reaches its maximum, it stops recharging.

This version adds 'Football Cards' style uses for the Mod. See the included file "Customizing PointsMod.html" for details.

Also, there is a "Mute/Unmute user" style for this mod, available from BoardMod/FINAL Mods for SP1.3/PointsMod 1.2.1, page 6.

Version: 1.2.1

Supports: YaBB 1.3.1, most likely SP1.3 too..

Features:
- can place a comment on why points were taken or given
- Moderator notes/comments are protected from user editing
- Moderator comments can be hidden from the public:
    - Everyone sees notes & points
    - Everyone sees points
    - Only poster, moderators, admin
- can both increment and decrement the counter
- counter can be displayed in the profile:
    - as plaintext
    - as a % gauge
    - as a custom gauge (see included file "Customizing PointsMod.txt")
- profile displays a "list of offenses", which contains:
    - Post date, subject and modification done by moderator
- can set recharge time (in days)
- can set recharge time separately for positive and negative counter values
- can toggle between "admin only"/"admin and moderators"
- can set default and max. amounts for counter
- can set maximum Poster's licence points change for one modification, modes:
    - No limit (text-field)
    - Constrain (drop-down select)
    - Validate (text-field with warning)
- can turn mod on/off from Admin settings
- can send "points low" warning:
    - None (off)
    - Send IM
    - Show popup
- Improved "list of offenses"

Current version adds these features:
- Fixed another bug.
- Fixed 2 bugs.
- Settings now contained in their own PointsMod admin area
- Moderator notes can be modified later (can also be turned off)
- Added user points display to posts:
      - None (off)
      - Plaintext
      - Mini-Gauge
      - Custom
- User points can be modified by Admin in Modify profile
- User points now displayed in Modify points:
      - Plaintext (default)
      - Custom (if supplied)
- User points modification can now be customized in custom modes.
- Added Manual for .pm_gauge files.

Installation:
Apply the mod.

Upload (in ASCII mode):
pm_settings.pl
to your Variables folder.

Upload the modified files (in ASCII mode):
english.lng
YaBB.pl
Sources/Profile.pl
Sources/Load.pl
Sources/Post.pl
Sources/ModifyMessage.pl
Sources/Display.pl
Sources/SubList.pl
Sources/Admin.pl
Sources/YaBBC.pl
Sources/InstantMessage.pl
Sources/Subs.pl

Upload (in ASCII mode):
PointsMod.pl
cards.pm_gauge
to your Sources folder.

Upload (in Binary mode):
The .gif images to your Images folder.

Total development time for mod (days): 5 days + bug fixes.
</mod info>

<author>
mixu
</author>

<homepage>

</homepage>

<edit file>
Sources\Profile.pl
</edit file>

<search for>
	$online =~ s~\?~<i>$txt{'687'}</i>.~;
	if($memsettings[6] > 100000) { $memsettings[6] = "$txt{'683'}"; }
</search for>

<add after>
    &pm_LoadUserPoints($INFO{'username'});
    my $pm_t1 = int(($userpdt[0]/$pm_max_value)*100);
    if ($pm_profilestyle == 1) {
        my $pm_t2 = int($pm_t1*1.5); # true max width is 150 px + 5 + 5
        if ($pm_t2 > 150) {$pm_t2 = 150;}
        $pointsmod_memberp = qq~<img src="$imagesdir/pm_bar1_1.gif" alt=""><img src="$imagesdir/pm_bar1_2.gif" height="11" width="$pm_t2" alt=""><img src="$imagesdir/pm_bar1_3.gif" alt=""> @userpdt[0]/$pm_max_value <i>($pm_t1 %)</i>~;
    } elsif (($pm_profilestyle == 2) && defined($pm_custom_filename) && $pm_custom_filename ne '') {
        &pm_LoadCustomProfileDisplay($pm_custom_filename);
        if ($pm_custom_images_type eq '%') {
            my $tens = (int($pm_t1/10))*10;
            my $i;
            if ($tens < 0) {$tens -= 10; $i = 100;} else {$tens +=10; $i = 0;}
                while(1){
                if (($tens < 0) && ($i < $tens)) {last;}
                if (($tens > 0) && ($i > $tens)) {last;}
                if (($pm_custom_images{"<$i%"} ne '')){
                    $pointsmod_memberp = $pm_custom_images{"<$i%"};
                }

                if ($tens < 0) {$i = $i - 10;} else {$i = $i + 10;}
            }
        } elsif ($pm_custom_images_type eq 'e') {
            my $i = $userpdt[0];
            if ($i < 0) {$pointsmod_memberp = $pm_custom_images{('<0e')} }
            while ($i > -1) {
                if (($pm_custom_images{('='.$i.'e')} ne '')){
                    $pointsmod_memberp = $pm_custom_images{('='.$i.'e')};
                    last;
                }
                $i--;
            }
        }
    } else {
        # 0 - defaults to plaintext
        $pointsmod_memberp = "@userpdt[0]/$pm_max_value";
    }

    if ($pm_custom_implements_link_to_offenseslist == 0){
        $pointsmod_memberp .= qq~<br><font size="-2">[<a href="$scripturl?action=pm_offenses;username=$INFO{'username'}">$pointsmod{'25'}</a>]</font>~;
    }
</add after>

<search for>
      </tr><tr>
        <td><font size=2><b>$txt{'86'}: </b></font></td>
        <td><font size=2>$memsettings[6]</font></td>
      </tr><tr>
</search for>

<add after>
      ~;
    if ($pm_on_off == 1) {
        $yymain .= qq~
            <td><font size=2><b>$pointsmod{'1'}: </b></font></td>
            <td><font size=2>$pointsmod_memberp</font></td>~;
    }
    $yymain .= qq~</tr><tr>
</add after>

<search for>
		if($settings[7] eq 'Administrator') {
			unlink("$memberdir/$member{'username'}.dat");
			unlink("$memberdir/$member{'username'}.msg");
			unlink("$memberdir/$member{'username'}.log");
	                unlink("$memberdir/$member{'username'}.outbox");
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.pdt");
</add after>

<search for>
		elsif( $member{'username'} eq $username ) {
			unlink("$memberdir/$username.dat");
			unlink("$memberdir/$username.msg");
			unlink("$memberdir/$username.log");
	                unlink("$memberdir/$username.outbox");
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.pdt");
</add after>

<search for>
	$yymain .= qq~
<form action="$cgi;action=profile2" method="POST" name="creator">
<table border=0 width=720 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" height="30">
    &nbsp;<img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'79'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" height="25"><BR><font size="1">$txt{'698'}</font><BR><BR></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'517'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 width="100%" cellpadding="3">
      <tr>
	<td width="320"><font size=2><b>$txt{'35'}: </b></font></td>
	<td><font size=2><input type="hidden" name="username" value="$INFO{'username'}">$INFO{'username'}</font></td>
      </tr><tr>
</search for>

<add after>
~;
&pm_LoadUserPoints($INFO{'username'});
if ($settings[7] ne 'Administrator') {
$yymain .= qq~
	<td width="320"><font size=2><b>$pointsmod{'1'}: </b></font></td>
	<td><font size=2><input type="hidden" name="pm_points" value="$userpdt[0]">$userpdt[0]</font></td>
      </tr><tr>
~;
} else {
$yymain .= qq~
	<td width="320"><font size=2><b>$pointsmod{'1'}: </b></font></td>
	<td><font size=2><input type="text" name="pm_points" size=4 value="$userpdt[0]"></font></td>
      </tr><tr>
~;
}
$yymain .= qq~
</add after>

<search for>
	# make sure this person has access to this profile
	if($username ne $member{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if( $settings[7] ne 'Administrator' ) {
		$member{'username'} = $username;
		$member{'settings6'} = $settings[6];
		$member{'settings7'} = $settings[7];
	}
</search for>

<add after>
	if ($settings[7] eq 'Administrator'){
        &pm_LoadUserPoints($member{'username'});
        $userpdt[0] = $member{'pm_points'}|| $userpdt[0];
        &pm_SaveUserPoints($member{'username'});
    }
</add after>

<edit file>
Sources\Load.pl
</edit file>

<search for>
sub LoadIMs {
</search for>

<add before>
sub pm_ceil_positive{
    my $num = shift;
    my $ceil = -1;
    while($num >= 0){
       $ceil++;
       $num--;
    }
    if($num > -1) {
        $ceil++;
    }
    return $ceil;
}

sub pm_LoadUserPoints {
	my $user = shift;
	my $ydaytimediff;
    @userpdt = undef;
    if(fopen(PDATA, "$memberdir/$user.pdt")){
        @userpdt = <PDATA>;
        fclose(PDATA);
        chomp @userpdt;
        $ydaytimediff = ((gmtime(time-$userpdt[1]))[7]);
        if ((($userpdt[0] < -1)
            && ($ydaytimediff >= $pm_days_negative_increment))
          || (($userpdt[0] > -1)
            && ($ydaytimediff >= $pm_days_positive_increment)))
          {
            if ($userpdt[0] < $pm_max_value){
                if ($ydaytimediff >= $pm_days_positive_increment) {$ydaytimediff = pm_ceil_positive($ydaytimediff/$pm_days_positive_increment);}
                if ($ydaytimediff >= $pm_days_negative_increment) {$ydaytimediff = pm_ceil_positive($ydaytimediff/$pm_days_negative_increment);}
                $userpdt[0] = $userpdt[0]+$ydaytimediff;
                $userpdt[1] = time;
                push(@userpdt, ("-1|$pointsmod_sources{'auto'}|-1|-1|+|$ydaytimediff|$pointsmod{'61'}.|$date|$pointsmod{'61'}."));
                &pm_SaveUserPoints($user);
            }
        }
    } else {
        @userpdt = ($pm_default_value, '-1');
    }
}

sub pm_LoadCustomProfileDisplay{
    my $displayname = shift;
    require "$displayname";
}

sub pm_SaveUserPoints{
	my $user = shift;
    if(fopen(PDATA, ">$memberdir/$user.pdt", 1)){
        foreach (@userpdt){
		print PDATA $_."\n";
		}
    fclose(PDATA);
    }
}

</add before>

<search for>
	if($userprofile{$user}->[6] > 100000) { $userprofile{$user}->[6] = "$txt{'683'}"; }
</search for>

<add after>
    &pm_LoadUserPoints($user);
    $user_display_pdt{$user} = @userpdt[0];
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>
# PointsMod 1.2
$pointsmod{'0'} = 'PointsMod 1.2 for YaBB SP 1.3.1';
$pointsmod{'1'} = "Poster's licence points";
$pointsmod{'2'} = "poster's licence points";
$pointsmod{'3'} = "You can't post right now <b>because you have negative $pointsmod{'2'}</b>.<br>You will need to wait a few days until you are at 0 $pointsmod{'2'}.";
$pointsmod{'4'} = "You can't modify posts right now <b>because you have negative $pointsmod{'2'}</b>.<br>You will need to wait a few days until you are at 0 $pointsmod{'2'}.";
$pointsmod{'5'} = "Edit points";
$pointsmod{'6'} = qq~<img src="$imagesdir/pm_edit.gif" alt=""> Modify $pointsmod{'2'}~;
$pointsmod{'7'} = "Modify $pointsmod{'2'} for user";
$pointsmod{'8'} = 'Amount';
$pointsmod{'9'} = "(When the user's $pointsmod{'2'} goes under 0, he/she cannot post.)";
$pointsmod{'10'} = 'Add an comment to the post?';
$pointsmod{'11'} = '(Adds an explanatory remark to the end of this post.)';
$pointsmod{'12'} = 'Explanation for modification:';
$pointsmod{'13'} = 'Submit';
$pointsmod{'14'} = 'This post was smited';
$pointsmod{'15'} = 'This post was applauded';
$pointsmod{'16'} = 'points';
$pointsmod{'17'} = 'by';
$pointsmod{'18'} = 'Allow moderators to use PointsMod??';
$pointsmod{'19'} = 'How many days to gain one point while point count is negative?';
$pointsmod{'20'} = 'How many days to gain one point while point count is positive?';
$pointsmod{'21'} = 'Users start with ';
$pointsmod{'22'} = 'Maximum amount of points is ';
$pointsmod{'23'} = 'Maximum change allowed:';
$pointsmod{'24'} = "<b>Maximum change allowed is $pm_max_change!!</b> You can't set an amount higher than that.";
$pointsmod{'25'} = 'List of offenses';
$pointsmod{'26'} = 'for';
$pointsmod{'27'} = 'Points';
$pointsmod{'28'} = 'Select profile page display type';
$pointsmod{'29'} = 'Plaintext';
$pointsmod{'30'} = 'Gauge';
$pointsmod{'31'} = 'Custom';
$pointsmod{'32'} = 'Select "Custom"-mode gauge file';
$pointsmod{'33'} = 'Mode for Maximum points change enforcement';
$pointsmod{'34'} = 'No limit (text-field)';
$pointsmod{'35'} = 'Constrain (drop-down select)';
$pointsmod{'36'} = 'Validate (text-field with warning)';
$pointsmod{'37'} = 'Maximum points change limit (for each modification)';
$pointsmod{'38'} = 'Mode for showing moderator notes';
$pointsmod{'39'} = 'Everyone sees notes & points';
$pointsmod{'40'} = 'Everyone sees points';
$pointsmod{'41'} = 'Only poster, moderators, admin';
$pointsmod{'42'} = 'This dialog shows all posts by ';
$pointsmod{'43'} = ' which have been commented by moderators.';
$pointsmod{'44'} = 'No commented posts found for this user.';
$pointsmod{'45'} = "Enable $pointsmod{'0'}?";
$pointsmod{'46'} = ' <i>(Checked = on, unchecked = off)</i>';
$pointsmod{'47'} = " <i>(Moderator's can't use PointsMod if it's not enabled)</i>";
$pointsmod{'48'} = 'Warning';
$pointsmod{'49'} = " $pointsmod{'1'} low!";
$pointsmod{'50'} = "Your $pointsmod{'1'} are running low. If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators. NOTE: This warning is sent to you automatically.";
$pointsmod{'51'} = 'Automatic "points-low" warning method:';
$pointsmod{'52'} = "$pointsmod{'1'} count for auto warning at:";
$pointsmod{'52a'} = 'Automatic warning';
$pointsmod{'52b'} = 'popup';
$pointsmod{'52c'} = 'IM';
$pointsmod{'53'} = "$pointsmod{'52a'} $pointsmod{'52c'} subject:";
$pointsmod{'54'} = "$pointsmod{'52a'} $pointsmod{'52c'} message:";
$pointsmod{'55'} = "$pointsmod{'52a'} $pointsmod{'52b'} title:";
$pointsmod{'56'} = "$pointsmod{'52a'} $pointsmod{'52b'} body:";
$pointsmod{'57'} = 'settings';
# removed
$pointsmod{'59'} = qq~ <table bgcolor="$windowbg2" class="windowbg2"><tr><td><b>Your $pointsmod{'1'} are running low.</b></td><td>If they become negative, you can no longer post to this forum - please try to follow the posting policy enforced by our board's moderators. NOTE: This warning is sent to you automatically.</td></tr></table>~;
$pointsmod{'60'} = 'You have ';
$pointsmod{'61'} =  'Automatic points regeneration';
$pointsmod{'62'} =  'PointsMod 1.2 Settings';
$pointsmod{'63'} =  'Modify existing comments';
$pointsmod{'64'} =  'Comment';
$pointsmod{'65'} = 'Existing comments';
$pointsmod{'66'} = 'Allow editing of moderator comments?';
$pointsmod{'67'} = 'Mini-gauge';
$pointsmod{'68'} = 'Select user points indicator type (in posts)';
$pointsmod{'69'} = 'None (off)';
$pointsmod{'70'} = 'Current points';
$pointsmod{'71'} = 'Set to';
$pointsmod{'72'} = qq~Allow direct "set to" in modify $pointsmod{'2'}~;
$pointsmod{'73'} = qq~<br>Please see the included file "Customizing PointsMod.html"<br>- <b>to use this setting effectively, <br>you may be required to edit your $pointsmod{'1'} $pointsmod{'57'}!!</b>~;
$pointsmod{'58'} = 'Visual';
# end PointsMod 1.2

%pointsmod_sources=(
'auto' => -2
);
</add after>

<search for>
if($MenuType == 1) {
	$menusep = ' | ';
	$img{'admin'} = qq~<font size="1" class="imgmenu">$txt{'2'}</font>~;
</search for>

<add after>
$img{'pm_edit'} = qq~<font size="1" class="imgcatbg">$pointsmod{'5'}</font>~;
</add after>

<search for>
else {
	$menusep = ' ';
	$img{'admin'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'2'}" border="0"> <font size="1" class="imgmenu">$txt{'2'}</font>~;
</search for>

<add after>
$img{'pm_edit'} = qq~<font size="1" class="imgcatbg"><img src="$imagesdir/pm_edit.gif" alt="$pointsmod{'5'}" border="0">$pointsmod{'5'}</font>~;
</add after>

<edit file>
Sources\Post.pl
</edit file>

<search for>
sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'3'}); }
</add after>

<search for>
sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'3'}); }
</add after>

<search for>
		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
</search for>

<add after>
            @pm_points = undef;
            @pm_notes = undef;
            $mmessage = pm_DeUBBCProcess($mmessage);
</add after>

<search for>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
      <tr>
        <td bgcolor="$color{'bordercolor'}" colspan="2" class="bordercolor">
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
~;
}
</search for>

<add after>
my $iterator;
for($iterator = 0; $iterator <= scalar(@pm_points); $iterator++){
    if ($pm_points[$iterator] ne '') {
    $yymain .= qq~<input type="hidden" name="pm_points$iterator" value="$pm_points[$iterator]">~;
    }
}
for($iterator = 0; $iterator <= scalar(@pm_notes); $iterator++){
    if ($pm_notes[$iterator] ne '') {
    $yymain .= qq~<input type="hidden" name="pm_notes$iterator" value="$pm_notes[$iterator]">~;
    }
}
</add after>

<search for>
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	if (length($sub) > 50) { $sub = substr($sub,0,50); }
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	&CheckIcon;
</search for>

<add after>
    if($FORM{'previewmodify'}){
        my $iterator = 1;
        while(defined($FORM{"pm_points$iterator"})){
            $message .= '[pm_moderation_note='.$FORM{"pm_points$iterator"}.'pm_end]'.$FORM{"pm_notes$iterator"}.'[/pm_moderation_note]';
            $iterator++;
        }
        @pm_points = undef;
        @pm_notes = undef;
# Uncomment if you would like to see Moderator notes on the preview...
#        my $load_message = $message;
#        $load_message = pm_DeUBBCProcess($message);
        $message = pm_DeUBBCProcess($message);
    }
</add after>

<edit file>
Sources\ModifyMessage.pl
</edit file>

<search for>
sub ModifyMessage {
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'4'}); }
</add after>

<search for>
sub ModifyMessage2 {
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] < 0) && ($settings[7] ne 'Administrator')){ &fatal_error($pointsmod{'4'}); }
</add after>

<search for>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' ) {
		&fatal_error($txt{'67'});
	}

	$lastmod = $mlm ? &timeformat($mlm) : '-';
	$nscheck = $mns ? ' checked' : '';
</search for>

<add before>
    @pm_points = undef;
    @pm_notes = undef;
    $message = pm_DeUBBCProcess($message);
</add before>

<search for>
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~ );
		$message =~ s/\cM//g;
		$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
		$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
		$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
		&ToHTML($message);
		$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
		$message =~ s/\n/<br>/g;
</search for>

<add after>
    my $iterator = 1;
    while(defined($FORM{"pm_points$iterator"})){
        $message .= '[pm_moderation_note='.$FORM{"pm_points$iterator"}.'pm_end]'.$FORM{"pm_notes$iterator"}.'[/pm_moderation_note]';
        $iterator++;
    }
</add after>

<edit file>
Sources\Display.pl
</edit file>

<search for>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
		$yymain .= qq~  $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1" onclick="return confirm('$txt{'739'}')">$img{'delete'}</a>~;
	}
</search for>

<add after>
    if(($settings[7] eq 'Administrator') || (($pm_allow_moderators == 1) && (exists $moderators{$username}))) {
        if (($musername ne 'Guest') && ($pm_on_off == 1)) {
            $yymain .= qq~  $menusep<a href="$cgi;action=pm_edit;message=$counter;thread=$viewnum;musername=$userprofile[1]">$img{'pm_edit'}</a>~;
        }
    }
</add after>

<search for>
		# If the user isn't a guest, load his/her info.
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
</search for>

<add after>
            $pm_userpoints = $user_display_pdt{$musername};
</add after>

<search for>
	if($musername ne "Guest") {
		$yymain .= qq~
            $star<BR><BR>
            $userprofile[13]$userprofile[12]
</search for>

<add after>
~;
    if ($pm_on_off == 0){}
    elsif($pm_user_display_type == 0){
		$yymain .= qq~<br>$pointsmod{'1'}: <a href="$scripturl?action=pm_offenses;username=$musername"><i>$pm_userpoints/$pm_max_value</i></a>~;
	} elsif($pm_user_display_type == 1){
        my $gaugewidth = int(($pm_userpoints/$pm_max_value)*75);
        if ($gaugewidth > 75) {$gaugewidth = 75;}
        $otherwidth = 75 - $gaugewidth;
        $yymain .= qq~$pointsmod{'1'}: <table cellspacing=0 cellpadding=0 width=150 height=6><tr><td width=150 height=6><img src="$imagesdir/pm_usergauge2.gif" alt=""><img src="$imagesdir/pm_usergauge.gif" height="6" width="$gaugewidth" alt=""><img src="$imagesdir/pm_usergauge3.gif" height=6 width=$otherwidth alt=""><img src="$imagesdir/pm_usergauge2.gif" alt=""> <a href="$scripturl?action=pm_offenses;username=$musername"><font size="-2"><i>$pm_userpoints/$pm_max_value</i></font></a></td></tr></table>~;
	} elsif($pm_user_display_type == 3){
	   # custom
    if (($pm_profilestyle == 2) && defined($pm_custom_filename) && $pm_custom_filename ne '') {
        my $pm_t1 = int(($pm_userpoints/$pm_max_value)*100);
        &pm_LoadCustomProfileDisplay($pm_custom_filename);
        if ($pm_custom_post_display_type eq '%') {
            my $tens = (int($pm_t1/10))*10;
            my $i;
            if ($tens < 0) {$tens -= 10; $i = 100;} else {$tens +=10; $i = 0;}
                while(1){
                if (($tens < 0) && ($i < $tens)) {last;}
                if (($tens > 0) && ($i > $tens)) {last;}
                if (($pm_custom_post_display{"<$i%"} ne '')){
                    $pm_out = $pm_custom_post_display{"<$i%"};
                }

                if ($tens < 0) {$i = $i - 10;} else {$i = $i + 10;}
            }
        } elsif ($pm_custom_post_display_type eq 'e') {
            my $i = $pm_userpoints;
            if ($i < 0) {$pm_out = $pm_custom_post_display{('<0e')} }
            while ($i > -1) {
                if (($pm_custom_images{('='.$i.'e')} ne '')){
                    $pm_out = $pm_custom_post_display{('='.$i.'e')};
                    last;
                }
                $i--;
            }
        }
        $yymain .= $pm_out;
    }
    }
		$yymain .= qq~

</add after>

<edit file>
Sources\SubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'pm_admin',"PointsMod.pl&pm_Admin",
'pm_admin2',"PointsMod.pl&pm_Admin2",
'pm_edit',"PointsMod.pl&pm_Edit",
'pm_edit2',"PointsMod.pl&pm_Edit2",
'pm_offenses',"PointsMod.pl&pm_OffensesList",
'pm_note_popup',"PointsMod.pl&pm_NotePopup",
</add after>

<edit file>
Sources\Admin.pl
</edit file>

<search for>
	unlink("$memberdir/$currentmem.dat");
	unlink("$memberdir/$currentmem.msg");
	unlink("$memberdir/$currentmem.log");
	unlink("$memberdir/$currentmem.outbox");
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.pdt");
</add after>

<search for>
        - <a href="$cgi;action=modsettings">$txt{'222'}</a><br>
        - <a href="$cgi;action=editnews">$txt{'7'}</a><br>
        - <a href="$cgi;action=modtemp">$txt{'216'}</a><br>
        - <a href="$cgi;action=modagreement">$txt{'764'}</a><br>
        - <a href="$cgi;action=setcensor">$txt{'135'}</a>
</search for>

<add after>
<br>        - <a href="$cgi;action=pm_admin">$pointsmod{'62'}</a>
</add after>

<edit file>
Sources\Subs.pl
</edit file>

<search for>
sub exit {
	local $| = 1;
	local $\ = '';
	print '';
	CORE::exit( $_[0] || 0 );
}
</search for>

<add after>
sub pm_DeUBBCProcess {
    my $line = shift;
    while($line =~ s~\[pm_moderation_note=(.+?)pm_end\](.+?)\[/pm_moderation_note\]~~i){
        push @pm_points, $1;
        push @pm_notes, $2;
    }
    return $line;
}

</add after>

<search for>
sub template {
	if($yySetCookies1 || $yySetCookies2) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }

	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";

	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$helpfile" target="_blank" style="cursor:help;">$img{'help'}</a>$menusep<a href="$cgi;action=search">$img{'search'}</a>$menusep<a href="$scripturl?action=mlall">$img{'memberlist'}</a>~;
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
	if($username eq 'Guest') { $yymenu .= qq~$menusep<a href="$scripturl?action=login">$img{'login'}</a>$menusep<a href="$cgi;action=register">$img{'register'}</a>~;
	} else {
		$yymenu .= qq~$menusep<a href="$cgi;action=profile;username=$useraccount{$username}">$img{'profile'}</a>~;
		if($enable_notification) { $yymenu .= qq~$menusep<a href="$cgi;action=shownotify">$img{'notification'}</a>~; }
		$yymenu .= qq~$menusep<a href="$cgi;action=logout">$img{'logout'}</a>~;
	}
</search for>

<add after>
    &pm_LoadUserPoints($username);
    if ((@userpdt[0] <= $pm_notify_when) && $pm_notify_mode == 2){
        if (fopen(FILE,"$datadir/pm_notify.txt")) {
            @pm_notify = <FILE>;
            fclose(FILE);
        }
        my $i;
    	for ($i = 0; $i <= scalar(@pm_notify)+1; $i++) {
    	   	if ($pm_notify[$i] eq $username) {
               	$yymenu .= qq~
<script language="JavaScript" type="text/javascript">
<!--
window.open("$cgi;action=pm_note_popup", "pm_note_popup", "width=300,height=180,location=0,menubar=0,directories=0,toolbar=0,status=0");
// -->
</script>
~;
            last;
            }
	    }
	    if ($i <= scalar(@pm_notify)) {
        		if (fopen(FILE, ">$datadir/pm_notify.txt", 1)) {
                    my $j;
                	for ($j = 0; $j <= scalar(@pm_notify); $j++){
                		if($j != $i) {print FILE $pm_notify[$j];}
                	}
                	fclose(FILE);
              }
        }
	}
</add after>

<edit file>
Sources\YaBBC.pl
</edit file>

<search for>
	if( $message =~ m~\[table\](?:.*?)\[/table\]~is ) {
		while( $message =~ s~<marquee>(.*?)\[table\](.*?)\[/table\](.*?)</marquee>~<marquee>$1<table>$2</table>$3</marquee>~s ) {}
		while( $message =~ s~<marquee>(.*?)\[table\](.*?)</marquee>(.*?)\[/table\]~<marquee>$1\[//table\]$2</marquee>$3\[//table\]~s ) {}
		while( $message =~ s~\[table\](.*?)<marquee>(.*?)\[/table\](.*?)</marquee>~\[//table\]$1<marquee>$2\[//table\]$3</marquee>~s ) {}
		$message =~ s~\n{0,1}\[table\]\n*(.+?)\n*\[/table\]\n{0,1}~<table>$1</table>~isg;
		while( $message =~ s~\<table\>(.*?)\n*\[tr\]\n*(.*?)\n*\[/tr\]\n*(.*?)\</table\>~<table>$1<tr>$2</tr>$3</table>~is ) {}
		while( $message =~ s~\<tr\>(.*?)\n*\[td\]\n{0,1}(.*?)\n{0,1}\[/td\]\n*(.*?)\</tr\>~<tr>$1<td>$2</td>$3</tr>~is ) {}
                $message =~ s~<table>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)<tr>~<table><tr>~isg;
		$message =~ s~<tr>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)<td>~<tr><td>~isg;
		$message =~ s~</td>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)<td>~</td><td>~isg;
		$message =~ s~</td>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)</tr>~</td></tr>~isg;
		$message =~ s~</tr>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)<tr>~</tr><tr>~isg;
		$message =~ s~</tr>((?:(?!<tr>|</tr>|<td>|</td>|<table>|</table>).)*)</table>~</tr></table>~isg;
	}
</search for>

<add after>
    if ($pm_on_off == 0) {
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~~isg;
    } elsif (
     # $pm_restrict_moderator_notes == everyone sees all
     ($pm_restrict_moderator_notes == 0)
     # or user is moderator, or admin
     ||($settings[7] eq 'Administrator' || (exists $moderators{$username}))
     # or this user is the poster
     ||($username eq $musername)
    ){
        # show notes and points
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~<p>$1: $2</p>~isg;
    } elsif (
     # $pm_restrict_moderator_notes == everyone sees points
     ($pm_restrict_moderator_notes == 1)
    ){
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~<p>$1.</p>~isg;
    } else {
        $message =~ s~\[pm_moderation_note=(.+?)pm_end\](.*?)\[/pm_moderation_note\]~~isg;
    }

</add after>

<edit file>
Sources\InstantMessage.pl
</edit file>

<search for>
#if there were invalid usernames in the recipient list, these names are listed after all valid users have been IMed
if (@nouser) {
	$badusers = join(" $txt{'763'} ", @nouser);
	$badusers =~ s/; $txt{'763'}/;/;
	&fatal_error("$badusers $txt{'747'}");
}

$yySetLocation = qq~$cgi;action=im~;
</search for>

<add after>
if (defined($pm_IM_send) && $pm_IM_send ne ''){
    $yySetLocation = $pm_IM_send;
}
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
### Requirements and Errors ###
require "Settings.pl";
require "$language";
require "$sourcedir/Subs.pl";
require "$sourcedir/Load.pl";
require "$sourcedir/Security.pl";
</search for>

<add after>
require "$vardir/pm_settings.pl";
</add after>
